%define GLIBC_VERSION 2.1.3
Summary: GNU libc for Red Hat Linux 6.2 backwards compatibility
Name: compat-glibc
Version: 6.2
Release: %{GLIBC_VERSION}.2
Copyright: LGPL
Group: Development/Libraries
Source: glibc-%{GLIBC_VERSION}.tar.gz
Source1: linux-2.2.16-includes.tar.bz2
ExclusiveArch: i386 alpha sparc
# Other sources are available at:
#   http://www.ozemail.com.au/~geoffk/glibc-crypt/glibc-crypt-2.1.tar.gz
# In the source tarball the file diff-CYGNUS-to-REDHAT.patch contains all
# diffs applied by Red Hat to the current CVS version of glibc
Buildroot: /var/tmp/compat-glibc-%{version}-root

%description
This package contains the version %{GLIBC_VERSION} of the GNU C library for compiling
binaries that will run on Red Hat Linux 6.2 and other glibc 2.1.x Linux
based systems. This package includes the runtime libraries.

%prep
%setup -q -a 1 -n glibc-%{GLIBC_VERSION}

%ifarch armv4l
rm -rf glibc-compat
%endif

find . -type f -size 0 -o -name "*.orig" -exec rm -f {} \;

%build
rm -rf build-$RPM_ARCH-linux
mkdir build-$RPM_ARCH-linux ; cd build-$RPM_ARCH-linux
CC=egcs CFLAGS="$BuildFlags -g -O3" ../configure --prefix=/usr \
	--enable-add-ons=yes --without-cvs  --with-profile=no \
	--prefix=/usr/$RPM_ARCH-glibc21-linux \
	%{_target_cpu}-glibc21-linux
make -r CFLAGS="$BuildFlags -g -O3" PARALLELMFLAGS=-s

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
make install_root=$RPM_BUILD_ROOT install -C build-$RPM_ARCH-linux

# remove stuff that we have no use for
rm -rf $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/{bin,etc,info,sbin,share}
rm -f $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/lib/lib*_p.a
for lib in  $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/lib/lib*.a ; do
    [ -f ${lib%%.a}.so ] && rm -f $lib
done

%ifarch alpha
LIBC_SO_EXT=".1"
%else
LIBC_SO_EXT=""
%endif

# we know we want to use *this* one
cat > $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/lib/libc.so << EOF
/* GNU ld script
   Use the shared library, but some functions are only in
   the static library, so try that secondarily.  */
GROUP (
   /usr/$RPM_ARCH-glibc21-linux/lib/libc.so.6$LIBC_SO_EXT
   /usr/$RPM_ARCH-glibc21-linux/lib/ld-linux.so.2
   /usr/$RPM_ARCH-glibc21-linux/lib/libc_nonshared.a
      )
EOF

# Just drop in the kernel include headers...
cd linux-2.2.16/include
mv asm-$RPM_ARCH asm
tar chf - asm linux | tar xf - -C $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/include
cd ../..

# Strip everything
strip -R .comment $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/lib/*.so* || :

# Remove gconv
rm -rf $RPM_BUILD_ROOT/usr/$RPM_ARCH-glibc21-linux/lib/gconv

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%clean
rm -rf "$RPM_BUILD_ROOT"

%files
%defattr(-,root,root)
/usr/*-glibc21-linux/lib
/usr/*-glibc21-linux/include

%changelog
* Tue Jul 25 2000 Jakub Jelinek <jakub@redhat.com>
- Rename macros so that they don't confuse rpm
- Fix Alpha libc.so

* Sat Jul 16 2000 Jakub Jelinek <jakub@redhat.com>
- Transform into compat-glibc

* Fri Feb 25 2000 Cristian Gafton <gafton@redhat.com>
- fix c_stubs add-on to work around various assert()s in glibc
- add Davem's patch for _NPROCESSORS_ONLN on Sparc

* Fri Feb 25 2000 Cristian Gafton <gafton@redhat.com>
- add the c_stubs add-on
- sparc patch from davem

* Thu Feb 24 2000 Cristian Gafton <gafton@redhat.com>
- fix locale problems on 64 bit arches

* Tue Feb 22 2000 Cristian Gafton <gafton@redhat.com>
- cygnus sync up for fixes to nscd

* Thu Feb 17 2000 Cristian Gafton <gafton@redhat.com>
- updated to include new China timezones
- sync up with the locale changes from Cygnus

* Tue Feb 01 2000 Cristian Gafton <gafton@redhat.com>
- updated from cygnus branch
- fix syslog so that it will continuously try to fallback from SOK_DGRAM to
  SOCK_STREAM and backwards

* Mon Jan 31 2000 Cristian Gafton <gafton@redhat.com>
- update from cygnus branch
- compress man pages for the linuxthreads stuff

* Fri Jan 21 2000 Cristian Gafton <gafton@redhat.com>
- add Jakub's patch so we back out even more

* Thu Jan 20 2000 Cristian Gafton <gafton@redhat.com>
- back out the setrlimit changes (well, sort of)

* Mon Jan 03 2000 Cristian Gafton <gafton@redhat.com>
- make release from CVS server directly now
